/**
 * L2FProd.com Common Components 0.2-dev License.
 *
 * Copyright 2005 L2FProd.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.starbeans.modules.startip.tips;

import org.starbeans.modules.startip.DefaultTipModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import org.openide.util.ImageUtilities;
import org.starbeans.modules.startip.TipModel;
import org.starbeans.modules.startip.TipProvider;

/**
 *
 * @author gwaldon
 */
public final class DemoTip implements TipProvider {
    
    public static TipProvider getDefault() {
        return new DemoTip();
    }
    
    @Override
    public TipModel getTip() {
        TipModel model = new DefaultTipModel();
        
        // plain text
        model
                .add(new DefaultTip(
                        "sbtip1",
                        "This is the first tip This is the first tip This is the first tip This is the first tip This is the first tip This is the first tip\nThis is the first tip This is the first tip"));

        // html text
        model.add(new DefaultTip("sbtip2",
                "<html>This is an html <b>TIP</b><br><center>"
                + "<table border=\"1\">" + "<tr><td>1</td><td>entry 1</td></tr>"
                + "<tr><td>2</td><td>entry 2</td></tr>"
                + "<tr><td>3</td><td>entry 3</td></tr>" + "</table>"));

        // a Component
        model.add(new DefaultTip("sbtip3", new JTree()));

        // an Icon
        Icon todicon = new ImageIcon(ImageUtilities.loadImage(
                "org/starbeans/modules/startip/resources/tipoftheday16.png"));
        model.add(new DefaultTip("tip 4", todicon));
        
        return model;
    }
}
